%global namedreltag .Final
%global namedversion %{version}%{?namedreltag}
Name:          seam-solder
Version:       3.1.1
Release:       4%{?dist}
Summary:       A portable CDI extensions library
Group:         Development/Libraries
License:       ASL 2.0 and LGPLv2+
URL:           http://seamframework.org/Seam3/Solder
# git clone git://github.com/seam/solder seam-solder-3.1.1.Final
# (cd seam-solder-3.1.1.Final/ && git archive --format=tar --prefix=seam-solder-3.1.1.Final/ 3.1.1.Final | xz > ../seam-solder-3.1.1.Final.tar.xz)
Source0:       %{name}-%{namedversion}.tar.xz

BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: seam-parent
BuildRequires: weld-parent

%if %{?fedora} > 18
BuildRequires: geronimo-parent-poms
%endif

BuildRequires: cdi-api
BuildRequires: javassist
BuildRequires: jboss-el-2.2-api
BuildRequires: jboss-logging
BuildRequires: jboss-logging-tools
BuildRequires: jboss-servlet-3.0-api
BuildRequires: log4j
BuildRequires: slf4j

%if 0
# testsuite module deps
BuildRequires: mvn(org.jboss.arquillian.junit:arquillian-junit-container)
BuildRequires: mvn(org.jboss.seam.test:weld-ee-embedded)
# docs (solder-reference-guide) module deps
# https://github.com/pressgang
BuildRequires: mvn(org.jboss.maven.plugins:maven-jdocbook-plugin)
%endif

# test deps
BuildRequires: hamcrest
BuildRequires: junit
BuildRequires: mockito

BuildRequires: maven-local
BuildRequires: maven-compiler-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-provider-junit4

Requires:      cdi-api
Requires:      javassist
Requires:      jboss-el-2.2-api
Requires:      jboss-logging
Requires:      jboss-logging-tools
Requires:      jboss-servlet-3.0-api
Requires:      log4j
Requires:      slf4j

Requires:      java
Requires:      jpackage-utils
BuildArch:     noarch

%description
A portable CDI extensions library for developing CDI applications,
frameworks or other extensions.

%package javadoc
Group:         Documentation
Summary:       Javadoc for %{name}
Requires:      jpackage-utils

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{namedversion}

%pom_remove_plugin org.codehaus.mojo:emma-maven-plugin
%pom_remove_plugin org.sonatype.maven.plugin:emma4it-maven-plugin

# unavailable deps
# org.jboss.seam.test:weld-ee-embedded-1.1
%pom_disable_module testsuite

# disabled, this module is jboss-logging re-packaged library, with shade plugin. use jboss-logging directly
%pom_disable_module logging
%pom_remove_dep org.jboss.solder:solder-logging api
%pom_add_dep org.jboss.logging:jboss-logging api
sed -i "s|org.jboss.solder.logging.internal|org.jboss.logging|" $(find api -name "*.java") \
  tooling/src/main/java/org/jboss/solder/tooling/SolderLoggers.java

# unavailable pom
%pom_remove_dep org.jboss.seam:seam-bom

%pom_remove_dep org.jboss.logging:jboss-logging-generator tooling
%pom_add_dep org.jboss.logging:jboss-logging-processor tooling

sed -i "s|org.jboss.logging.generator|org.jboss.logging.processor|" \
  tooling/src/main/java/org/jboss/solder/tooling/SolderLoggers.java \
  tooling/src/main/java/org/jboss/solder/tooling/SolderAnnotations.java \
  tooling/src/main/java/org/jboss/solder/tooling/AptHelperImpl.java \
  tooling/src/main/resources/META-INF/services/javax.annotation.processing.Processor

cp -p tooling/src/main/resources/META-INF/services/org.jboss.logging.generator.Annotations \
  tooling/src/main/resources/META-INF/services/org.jboss.logging.processor.Annotations
cp -p tooling/src/main/resources/META-INF/services/org.jboss.logging.generator.Loggers \
  tooling/src/main/resources/META-INF/services/org.jboss.logging.processor.Loggers
cp -p tooling/src/main/resources/META-INF/services/org.jboss.logging.generator.apt.AptHelper \
  tooling/src/main/resources/META-INF/services/org.jboss.logging.processor.apt.AptHelper

# this test fails
rm -r impl/src/test/java/org/jboss/solder/test/reflection/annotated/AnnotatedTypeBuilderTest.java

cp -p dist/src/main/assembly/license.txt .
cp -p dist/src/main/assembly/notice.txt .
sed -i 's/\r//' license.txt notice.txt

%build

mvn-rpmbuild package javadoc:aggregate

%install

mkdir -p %{buildroot}%{_javadir}/%{name}
install -m 644 api/target/solder-api.jar %{buildroot}%{_javadir}/%{name}/solder-api.jar
install -m 644 impl/target/solder-impl.jar %{buildroot}%{_javadir}/%{name}/solder-impl.jar
install -m 644 tooling/target/solder-tooling-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/solder-tooling.jar

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-parent.pom
install -pm 644 api/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-solder-api.pom
install -pm 644 impl/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-solder-impl.pom
install -pm 644 tooling/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-solder-tooling.pom

%add_maven_depmap JPP.%{name}-parent.pom
%add_maven_depmap JPP.%{name}-solder-api.pom %{name}/solder-api.jar
%add_maven_depmap JPP.%{name}-solder-impl.pom %{name}/solder-impl.jar
%add_maven_depmap JPP.%{name}-solder-tooling.pom %{name}/solder-tooling.jar

mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -rp target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}

%files
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/solder-*.jar
%{_mavenpomdir}/JPP.%{name}-*.pom
%{_mavendepmapfragdir}/%{name}
%doc license.txt notice.txt readme.md

%files javadoc
%{_javadocdir}/%{name}
%doc license.txt notice.txt

%changelog
* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.1.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 3.1.1-3
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Sun Dec 30 2012 gil cattaneo <puntogil@libero.it> 3.1.1-2
- fix license field

* Wed Nov 21 2012 gil cattaneo <puntogil@libero.it> 3.1.1-1
- initial rpm